<template>
  <div class="exam-type-manage">
    <div class="part-box part-box-filter part-box-flex">
      <div>
        <el-button type="primary" @click="toPage(1)">查询</el-button>
      </div>
      <div class="part-box-action">
        <el-button
          type="primary"
          icon="el-icon-circle-plus-outline"
          @click="toAdd"
          >新增类型</el-button
        >
      </div>
    </div>
    <div class="part-box part-box-pad">
      <el-table ref="TableList" :data="dataList">
        <el-table-column
          type="index"
          label="序号"
          width="70"
          :index="indexMethod"
        ></el-table-column>
        <el-table-column prop="name" label="类型名称"></el-table-column>
        <el-table-column prop="enable" label="状态" width="100">
          <template slot-scope="scope">
            {{ scope.row.enable | enableFilter }}
          </template>
        </el-table-column>
        <el-table-column class-name="action-column" label="操作" width="140">
          <template slot-scope="scope">
            <el-button
              :class="scope.row.enable ? 'btn-danger' : 'btn-primary'"
              type="text"
              @click="toEnable(scope.row)"
              >{{ scope.row.enable ? "禁用" : "启用" }}</el-button
            >
            <el-button
              class="btn-primary"
              type="text"
              @click="toEdit(scope.row)"
              >编辑</el-button
            >
            <el-button
              class="btn-danger"
              type="text"
              @click="toDelete(scope.row)"
              >删除</el-button
            >
          </template>
        </el-table-column>
      </el-table>
      <div class="part-page">
        <el-pagination
          background
          layout="total,prev, pager, next"
          :current-page="current"
          :total="total"
          :page-size="size"
          @current-change="toPage"
        >
        </el-pagination>
      </div>
    </div>

    <modify-exam-type
      :instance="curRow"
      @modified="getList"
      ref="ModifyExamType"
    ></modify-exam-type>
  </div>
</template>

<script>
import { examTypeListQuery, deleteExamType, ableExamType } from "../api";
import ModifyExamType from "../components/ModifyExamType.vue";

export default {
  name: "exam-type-manage",
  components: { ModifyExamType },
  data() {
    return {
      filter: {},
      current: 1,
      size: this.GLOBAL.pageSize,
      total: 0,
      dataList: [],
      curRow: {},
    };
  },
  mounted() {
    this.getList();
  },
  methods: {
    async getList() {
      const datas = {
        ...this.filter,
        pageNumber: this.current,
        pageSize: this.size,
      };
      const data = await examTypeListQuery(datas);
      this.dataList = data.records;
      this.total = data.total;
    },
    toPage(page) {
      this.current = page;
      this.getList();
    },
    toAdd() {
      this.curRow = {};
      this.$refs.ModifyExamType.open();
    },
    toEdit(row) {
      this.curRow = row;
      this.$refs.ModifyExamType.open();
    },
    toEnable(row) {
      const action = row.enable ? "禁用" : "启用";
      this.$confirm(`确定要${action}考试类型【${row.name}】吗?`, "提示", {
        type: "warning",
      })
        .then(async () => {
          const enable = !row.enable;
          await ableExamType({
            id: row.id,
            enable,
          });
          row.enable = enable;
          this.$message.success("操作成功！");
        })
        .catch(() => {});
    },
    async toDelete(row) {
      const result = await this.$confirm(
        `确定要删除类型【${row.name}】吗?`,
        "提示",
        {
          type: "warning",
        }
      ).catch(() => {});
      if (result !== "confirm") return;

      await deleteExamType([row.id]);
      this.$message.success("删除成功！");
      this.deletePageLastItem();
    },
  },
};
</script>
